<ng-container *ngIf="loading$ | async">
    <app-page-loading/>
</ng-container>

<ng-container *ngIf="error$|async as error">
    <app-page-error [payload]="error"></app-page-error>
</ng-container>

<ng-container *ngIf="!(error$ | async)">
    <app-title titulo="Facturas"></app-title>
    <div class="card flex justify-content-center w-12">
        <p-stepper>
            <p-stepperPanel header="Header I">
                <ng-template pTemplate="content" let-nextCallback="nextCallback" let-index="index">
                    <div class="flex flex-column h-12rem">
                        <div class="surface-border border-round flex-auto flex justify-content-center align-items-center font-medium">
                            <form [formGroup]="facturaForm" (ngSubmit)="submitForm()">
                                <div class="flex flex-column gap-2">
                                    <label for="nitCliente">Nit Cliente</label>
                                    <p-autoComplete 
                                        formControlName="nitCliente"
                                        [suggestions]="(nitsClientes$|async)!" 
                                        (completeMethod)="filterCliente($event)">
                                    </p-autoComplete>
                                    <br>
                                    <small *ngIf="facturaForm.controls['nitCliente'].getError('required') && facturaForm.controls['nitCliente'].touched" id="nombre-help">
                                        Nit del cliente es obligatorio
                                    </small>
                                </div>
                                <div class="flex flex-column gap-2">
                                    <p-button type="button" label="Crear nuevo"/>                          
                                </div>
                                <div class="flex flex-column gap-2">
                                    <label class="block font-bold mb-2" >Fecha de la factura</label>
                                    <input type="date" pInputText formControlName="fecha" />
                                    <small *ngIf="facturaForm.controls['fecha'].getError('required') && facturaForm.controls['fecha'].touched" id="nombre-help">
                                        La fecha debe ser valida
                                    </small>
                                </div>
                            </form>    
                        </div>
                    </div>
                    <div class="flex pt-4 justify-content-end">
                        <p-button 
                            label="Next" 
                            icon="pi pi-arrow-right" 
                            iconPos="right" 
                            (onClick)="nextCallback.emit()" />
                    </div>
                </ng-template>
            </p-stepperPanel>
            <p-stepperPanel header="Header II">
                <ng-template pTemplate="content" let-prevCallback="prevCallback" let-nextCallback="nextCallback" let-index="index">
                    <div class="flex flex-column gap-2 mx-auto">
                        <div class="flex-auto flex justify-content-center align-items-center font-medium">
                            <form [formGroup]="facturaForm" (ngSubmit)="submitForm()" >
                                <div class="flex flex-wrap justify-content-center gap-3" formArrayName="detalles" formArrayName="detalles">
                                    <div class="card flex flex-wrap gap-3 p-fluid" *ngFor="let detalle of detalles.controls; let i = index" [formGroupName]="i">
                                        <div class="flex-auto md:w-7">
                                            <label for="productoNombre-{{i}}">Producto</label>
                                            <p-autoComplete 
                                                id="productoNombre-{{i}}"
                                                formControlName="productoNombre"
                                                [suggestions]="(productos$|async )!" 
                                                (completeMethod)="filterProducto($event)"
                                                (onSelect)="cargarProducto($event, i)" >
                                            </p-autoComplete>
                                        </div>
    
                                        <div class="flex-auto md:w-1">                                    
                                            <label for="cantidad-{{i}}">Cantidad</label>
                                            <p-inputNumber id="cantidad-{{i}}" inputId="integeronly" formControlName="cantidad" (keypress)="calculateSubtotal(i)"/>
                                        </div>
    
                                        <div class="flex-auto md:w-2">                                    
                                            <label for="precioUnitario-{{i}}">Precio Unitario</label>
                                            <p-inputNumber 
                                                inputId="currency-us" 
                                                mode="currency" 
                                                currency="USD" 
                                                id="precioUnitario-{{i}}"
                                                formControlName="precioUnitario"
                                                locale="en-US" readonly/>
                                        </div>
    
                                        <div class="flex-auto md:w-2">                                    
                                            <label for="subtotal-{{i}}">Subtotal</label>
                                            <p-inputNumber 
                                            inputId="currency-us" 
                                            mode="currency" 
                                            currency="USD" 
                                            id="subtotal-{{i}}"
                                            formControlName="subtotal"
                                            locale="en-US" readonly/>
                                        </div>
                                        
                                        <div class="flex-auto md:w-2">  
                                            <p-button type="button" severity="danger" label="Remove" (click)="removeDetalle(i)"/>                                  
                                        </div>
                                    </div>
                                </div>
                                <p-button type="button" (click)="addDetalle()" label="Add Item"/>
                            </form>
                        </div>
                    </div>
                    <div class="flex pt-4 justify-content-between">
                        <p-button 
                            label="Back" 
                            icon="pi pi-arrow-left" 
                            (onClick)="prevCallback.emit()" />
                        <p-button 
                            label="Next" 
                            icon="pi pi-arrow-right" 
                            iconPos="right" 
                            (onClick)="nextCallback.emit()" />
                    </div>
                </ng-template>
            </p-stepperPanel>
            <p-stepperPanel header="Header III">
                <ng-template pTemplate="content" let-prevCallback="prevCallback" let-index="index">
                    <div class="flex flex-column mx-auto">
                        <div class="text-center card flex justify-content-center">
                            <p-panel header="Factura">
                            <p *ngIf="facturaForm.value.id">{{facturaForm.value.id}}</p>
                                <p>
                                    NitCliente: {{facturaForm.value.nitCliente}}
                                </p>
                                <p>
                                    Fecha: {{facturaForm.value.fecha| date: 'MMMM d, y'}}
                                </p>
                                <p-table [value]="facturaForm.value.detalles" [tableStyle]="{ 'min-width': '50rem' }">
                                    <ng-template pTemplate="header">
                                        <tr>
                                            <th>Producto</th>
                                            <th>Unidades</th>
                                            <th>Precio Unitario</th>
                                            <th>Subtotal</th>
                                        </tr>
                                    </ng-template>
                                    <ng-template pTemplate="body" let-product>
                                        <tr>
                                            <td>{{ product.productoNombre }}</td>
                                            <td>{{ product.cantidad }}</td>
                                            <td>{{ product.precioUnitario |currency}}</td>
                                            <td>{{ product.subtotal |currency}}</td>
                                        </tr>
                                    </ng-template>
                                </p-table>
                                <p>Total: <strong>{{facturaForm.value.total|currency}}</strong></p>
                            </p-panel>
                        </div>
                        <div class="flex pt-4 justify-content-end">
                            <p-button [disabled]="!facturaForm.valid" type="submit" (onClick)="submitForm()" label="Submit" icon="pi pi-check" iconPos="right" />
                        </div>
                    </div>
                    <div class="flex pt-4 justify-content-start">
                        <p-button 
                            label="Back" 
                            icon="pi pi-arrow-left" 
                            (onClick)="prevCallback.emit()" />
                    </div>
                </ng-template>
            </p-stepperPanel>
        </p-stepper>
    </div>
</ng-container>